/* makeIstFile.cc
---------------------------------------------------------------------
ϥǥåե뤫եץ
---------------------------------------------------------------------

=============
1. ǽ
=============

ʬϥǥåե뤫ե롣

===============================
2. ϥե롦ϥե
===============================

ϥեʬϥǥåե(suikei.idx)

ϥեϽե(all_grid.ist)

==================
3. Ȥ
=================

(1) ʤǵư硢
  % makeIstFile
  # index file : suikei.idx
  # initial state file : all_grid.ist

(2) Ĥǵư硢
  % makeIstFile suikei.idx all_grid.ist

================
4. ѥ
===============

% make

==================
5. ջ
==================

٤Ƥξ̤Фƽ̤ 0 Ȥʤ롣

*/

#include <stdio.h>
#include <stdlib.h>

int main(int argc, char** argv)
{
  // οΥå
  if (argc != 1 && argc != 3) {
    printf("Usage : makeIstFile indexFileName istFileName\n");
    exit(1);
  }

  char idx[256], ist[256];
  if (argc == 1) {
    printf("# index file : ");
    scanf("%s", idx);
    printf("# initial state file : ");
    scanf("%s", ist);
  }

  else {
    sscanf(argv[1], "%s", idx);
    sscanf(argv[2], "%s", ist);
  }

  FILE* fp_idx;
  FILE* fp_out;

  int i;

  int u_inside, u_online, d_inside, d_online;
  char sub_objname[50], slp_objname[50], net_objname[50];
  char buf[256];
  int num_input;                    // ήü
  int num_output;                   // ήü

  int tmp1, tmp2, tmp3, tmp4;
  char stmp1[50], stmp2[50], stmp3[50];

  if((fp_idx = fopen(idx, "r")) == NULL){
    printf("Cannot open index file.\n");
    exit(1);
  }

  fp_out = fopen(ist, "w");

  // եƬ˥Ȥ򵭤
  fprintf(fp_out, "# %s\n", ist);
  fprintf(fp_out, "# initial state of total_system\n\n");

  // ηϤΥ饹̾  ֥̾  ֹ֥
  fprintf(fp_out, "GridRiverBasin grb 0\n");

  // ηϤη׻ϻ
  fprintf(fp_out, "0\n");
  fprintf(fp_out, "{\n");

  while(fgets(buf, 256, fp_idx) != NULL){
    if((buf[0] == '#') || (buf[0] == '\n')) continue;
    if(sscanf(buf, "%s %d %d %d %d %s %d %d %s %d %s %d %s %s",
	      sub_objname, &u_inside, &u_online, &d_inside, &d_online,
	      stmp1, &tmp1, &tmp2, slp_objname, &tmp3, net_objname, &tmp4,
	      stmp2, stmp3) != 14){
      printf("Cannot scan index data.\n");
      exit(1);
    }

    num_input = u_inside + u_online;
    num_output = d_inside + d_online;

    fprintf(fp_out, "\n");

    // ʬϤΥ饹̾  ֥̾  ֹ֥
    fprintf(fp_out, "\tGridSub %s 0\n", sub_objname);
    fprintf(fp_out, "\t0\n\t{\n");

    // ƻǤΥ饹̾  ֥̾  ֹ֥
    fprintf(fp_out, "\t\tKsnet %s 0\n", net_objname);

    // ƻǤη׻ϻ
    fprintf(fp_out, "\t\t0\n");
    fprintf(fp_out, "\t\t");

    // ήüή
    for(i = 0; i < num_input; i++){
      fprintf(fp_out, "0.0 ");
    }
    fprintf(fp_out, "\n");

    // ¦ή
    fprintf(fp_out, "\t\t0.0\n");
    fprintf(fp_out, "\t\t");

    // ήüή
    for(i = 0; i < num_output; i++){
      fprintf(fp_out, "0.0 ");
    }
    fprintf(fp_out, "\n\n");

    // ǤΥ饹̾  ֥̾  ֹ֥
    fprintf(fp_out, "\t\tXaj %s 0\n", slp_objname);

    // ׻ϻ  I ν  storage ν
    fprintf(fp_out, "\t\t0 0.0 0.0\n");
    fprintf(fp_out, "\t}\n");
  }

  fprintf(fp_out, "\n}\n");

  fclose(fp_idx);
  fclose(fp_out);

  return 0;
}
